{{- define "main" -}}
<main class="container my-3">

<h1>News</h1>
<hr>

{{ $pages := .Paginator.Pages }}
{{ range $pages.ByPublishDate.Reverse }}
  <h2>{{ .Title }}</h2>
  <p class="text-muted"><time datetime="{{ .PublishDate.Format "2006-01-02" }}">{{ .PublishDate.Format "January 2, 2006" }}</time></p>

  <div class="mb-3">{{ .Summary }}</div>

  <a href="{{ .Permalink }}">Read full post</a>
  <hr>
{{ end }}

{{ $pag := .Paginator }}
{{ if gt $pag.TotalPages 1 }}
{{ $trail_before := 2 }}
{{ $trail_after := 2 }}

{{ $min_center := add $trail_before 1 }}
{{ $max_center := sub $pag.TotalPages $trail_after }}
{{ $path_center := $pag.PageNumber }}
{{ $path_center := cond (ge $path_center $min_center) $path_center $min_center }}
{{ $path_center := cond (le $path_center $max_center) $path_center $max_center }}
{{ $lower_limit := sub $path_center $trail_before }}
{{ $upper_limit := add $path_center $trail_after }}

{{ $trail := seq $lower_limit $upper_limit }}

  <nav aria-label="Page navigation">
    <ul class="pagination">
      {{ with $pag.HasPrev }}
      <li class="page-item">
        <a class="page-link" href="{{ $pag.First.URL }}">&laquo;</a>
      </li>
      <li class="page-item">
        <a class="page-link" href="{{ $pag.Prev.URL }}">&lsaquo;</a>
      </li>
      {{ else }}
      <li class="page-item disabled">
        <span class="page-link">&laquo;</span>
      </li>
      <li class="page-item disabled">
        <span class="page-link">&lsaquo;</span>
      </li>
      {{ end }}

      {{ range where $pag.Pagers "PageNumber" "in" (seq $lower_limit $upper_limit) }}
        <li class="page-item{{ if eq . $pag }} active{{ end }}">
          <a class="page-link" href="{{ .URL }}">{{ .PageNumber }}</a>
        </li>
      {{ end }}

      {{ if $pag.HasNext }}
        <li class="page-item">
          <a class="page-link" href="{{ $pag.Next.URL }}">&rsaquo;</a>
        </li>
        <li class="page-item">
          <a class="page-link" href="{{ $pag.Last.URL }}">&raquo;</a>
        </li>
      {{ else }}
        <li class="page-item disabled">
          <span class="page-link">&rsaquo;</span>
        </li>
        <li class="page-item disabled">
          <span class="page-link">&raquo;</span>
        </li>
      {{ end }}
    </ul>
  </nav>
{{ end }}

</main>
{{- end -}}
